#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   editStlFilesDialog
#
#       stlファイルのsolid名や倍率を変更する
#
#   13/10/31    新規作成
#      11/02    binaryの場合は、solid名、サイズとも空白で表示
#      11/03    binaryの場合も表示、ascii変換追加
#      12/21    stdout、stderrの設定（import logFileCreater）を追加
#

# generated by wxGlade 0.6.5 on Thu Oct 31 15:59:56 2013

import wx
import os
import sys
import glob
import math
import struct
import pyTreeFoam
import inputTextDDialog

import logFileCreater; logFileCreater.log()


# begin wxGlade: extracode
# end wxGlade


stlFiles = []
solidNames = []
stlSize = []
caseDir = ""
stlDir = ""


def Show(caseDirW, stlDirW):
    global caseDir, stlDir
    caseDir = caseDirW
    stlDir = stlDirW
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()




class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, _(u"stlファイルの編集"))
        self.static_line_1 = wx.StaticLine(self, -1)
        self.label_2 = wx.StaticText(self, -1, _(u"stlファイルのsolid名やscaleを変更する"))
        self.list_ctrl_1 = wx.ListCtrl(self, -1, style=wx.LC_REPORT | wx.SUNKEN_BORDER)
        self.label_3 = wx.StaticText(self, -1, _(u"stlファイルを選択し、各ボタンをクリックする事で変更できる。\n複数選択が可能。"))
        self.button_4 = wx.Button(self, -1, _(u"ascii変換"))
        self.button_1 = wx.Button(self, -1, _(u"solid名変更..."))
        self.button_2 = wx.Button(self, -1, _(u"scale変更..."))
        self.static_line_2 = wx.StaticLine(self, -1)
        self.button_3 = wx.Button(self, -1, _(u"閉じる"))

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onBinToAscii, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onChangeSolidName, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onChangeScale, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_3)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(_("frame_1"))
        self.list_ctrl_1.SetMinSize((450, 200))
        # end wxGlade

        self.SetTitle(_(u"stlファイルの編集"))
        #listCtrlの設定
        self.list_ctrl_1.InsertColumn(0, _(u"現在のサイズ(xyz)"), wx.LIST_FORMAT_LEFT, 150)
        self.list_ctrl_1.InsertColumn(0, _(u"solid名"), wx.LIST_FORMAT_LEFT, 100)
        self.list_ctrl_1.InsertColumn(0, _(u"file"), wx.LIST_FORMAT_LEFT, 50)
        self.list_ctrl_1.InsertColumn(0, _(u"stl"), wx.LIST_FORMAT_LEFT, 120)
        self.setDataToListCtrl()


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_5 = wx.BoxSizer(wx.VERTICAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 20)
        sizer_1.Add(self.static_line_1, 0, wx.ALL | wx.EXPAND, 5)
        sizer_1.Add(self.label_2, 0, wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_3.Add(self.list_ctrl_1, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 1, wx.EXPAND, 0)
        sizer_5.Add(self.label_3, 0, wx.LEFT | wx.RIGHT | wx.TOP | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_6.Add(self.button_4, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 10)
        sizer_6.Add(self.button_1, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 10)
        sizer_6.Add(self.button_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 10)
        sizer_5.Add(sizer_6, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_5.Add(self.static_line_2, 0, wx.ALL | wx.EXPAND, 5)
        sizer_7.Add((20, 15), 0, 0, 0)
        sizer_8.Add(self.button_3, 0, wx.RIGHT | wx.BOTTOM | wx.ALIGN_RIGHT, 20)
        sizer_7.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_5.Add(sizer_7, 1, wx.ALIGN_RIGHT, 0)
        sizer_4.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_4, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #ascii変換
    def onBinToAscii(self, event):  # wxGlade: MyFrame.<event_handler>
        self.binToAscii(event)

    #solid名変更
    def onChangeSolidName(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeSolidName(event)

    #scale変更
    def onChangeScale(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeScale(event)

    #閉じる
    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

# end of class MyFrame

    #  binToAscii
    #    fileFormatをbin→asciiに変換
    def binToAscii(self, event):
        global stlDir, stlFiles, stlSize
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
                solidName = solidNames[row]
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = u"エラー"
            mess = u"stlファイルを選択してください"
            self.errDialog(title, mess)
            return

        #倍率を変更
        for name in files:
            fileName = stlDir + "/" + name
            comm = "surfaceTransformPoints -scale '(1.0 1.0 1.0)' " + fileName + " " + fileName
            #os.system(comm)
            pyTreeFoam.runOFUtility(comm)
        #fileをtriSurfaceにコピー
        copyFileToTriSurface(caseDir, stlDir, files)
        #listBoxに反映
        self.setDataToListCtrl()


    #  changeScale
    #    scaleの変更
    def changeScale(self, event):
        global stlDir, stlFiles, stlSize
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
                solidName = solidNames[row]
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = u"エラー"
            mess = u"stlファイルを選択してください"
            self.errDialog(title, mess)
            return

        #変更する倍率を取得
        inputTextDDialog.title = _(u"倍率の入力")
        inputTextDDialog.message = _(u"変更する倍率を入力してください")
        inputTextDDialog.inputText = "1.0"
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            scale = inputTextDDialog.inputText
        else:
            return

        #倍率を変更
        for name in files:
            fileName = stlDir + "/" + name
            comm = "surfaceTransformPoints -scale '(" + scale + " " + scale + " " + scale + ")' " + fileName + " " + fileName
            #os.system(comm)
            pyTreeFoam.runOFUtility(comm)
        #fileをtriSurfaceにコピー
        copyFileToTriSurface(caseDir, stlDir, files)
        #listBoxに反映
        self.setDataToListCtrl()



    #  changeSolidName
    #    solidNameの変更
    def changeSolidName(self, event):
        global stlDir, stlFiles, solidNames
        #選択fileを取得
        files = []
        row = 0
        for stl in stlFiles:
            if self.list_ctrl_1.IsSelected(row) == True:
                files.append(stl)
                solidName = solidNames[row]
            row += 1
        #エラーチェック
        if len(files) == 0:
            title = u"エラー"
            mess = u"stlファイルを選択してください"
            self.errDialog(title, mess)
            return

        #変更するsolidNameを取得
        inputTextDDialog.title = _(u"solid名の入力")
        inputTextDDialog.message = _(u"新しいsolid名を入力してください")
        inputTextDDialog.inputText = solidName
        dialog = inputTextDDialog.MyDialog(None)
        result = dialog.ShowModal()
        if inputTextDDialog.status == "OK":
            newName = inputTextDDialog.inputText
        else:
            return

        #solid名を変更
        for stl in files:
            fileName = stlDir + "/" + stl
            #fileFmtをチェック
            #f=open(fileName); cont=f.read(80); f.close()
            #if cont[:5] == "solid":
            if isBinaryStl(fileName) == False:
                #asciiの場合
                f=open(fileName); lines=f.readlines(); f.close()
                i = 0
                for line in lines:
                    if line[:5] == "solid":
                        lines[i] = "solid " + newName + "\n"
                    i += 1
                f=open(fileName, "w")
                for line in lines:
                    f.write(line)
                f.close()
            else:
                f=open(fileName); cont=f.read(); f.close()
                header = newName.encode("utf-8") + "\00"*(80-len(newName))
                cont = header + cont[80:]
                f=open(fileName, "w"); f.write(cont); f.close()
        #fileをtriSurfaceにコピー
        copyFileToTriSurface(caseDir, stlDir, files)
        #listBoxに反映
        self.setDataToListCtrl()


    #
    #  setDataToListCtrl
    #    list_ctrlにデータセット
    def setDataToListCtrl(self):
        global stlFiles, solidNames, stlSize
        [stlFiles, fileFmt, solidNames, stlSize] = getStlFiles(stlDir)
        self.list_ctrl_1.DeleteAllItems()
        i = 0
        for stl in stlFiles:
            self.list_ctrl_1.InsertStringItem(i, stl)
            self.list_ctrl_1.SetStringItem(i, 1, fileFmt[i])
            self.list_ctrl_1.SetStringItem(i, 2, solidNames[i])
            size = stlSize[i]
            if size == [0.0, 0.0, 0.0]:
                 sizeStr = ""
            else:
                sizeStr = " ".join([str(size[0]), str(size[1]), str(size[2])])
            self.list_ctrl_1.SetStringItem(i, 3, sizeStr)
            i += 1

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



#
#  copyFileToTriSurface
#    fileをコピー
def copyFileToTriSurface(caseDir, stlDir, files):
    folder = caseDir + "/constant/triSurface"
    if len(glob.glob(folder)) == 0:
        comm = "mkdir " + folder
        os.system(comm)
    for name in files:
        comm = "cp " + stlDir + "/" + name + " " + folder + "/" + name
        os.system(comm)

#
#  getStlFiles
#    stlファイルのデータ取得
def getStlFiles(stlDir):
    fileFmt = []
    stlFiles = []
    solidNames = []
    stlSize = []
    files = glob.glob(stlDir+"/*.stl")
    files.sort()
    for fileName in files:
        #f=open(fileName); cont=f.read(80); f.close()
        if isBinaryStl(fileName) == False:
            fileFmt.append("ascii")
            [solidName, xVals, yVals, zVals] = getAsciiSolidNameStlSize(fileName)
        else:
            fileFmt.append("bin")
            [solidName, xVals, yVals, zVals] = getBinSolidNameStlSize(fileName)
        solidNames.append(solidName)
        if len(xVals) != 0:
            minx = min(xVals); maxx = max(xVals)
            miny = min(yVals); maxy = max(yVals)
            minz = min(zVals); maxz = max(zVals)
        else:
            minx=0.0; maxx=0.0
            miny=0.0; maxy=0.0
            minz=0.0; maxz=0.0
        dx = maxx - minx
        dy = maxy - miny
        dz = maxz - minz
        dx = getValueLog10(dx)
        dy = getValueLog10(dy)
        dz = getValueLog10(dz)
        stlSize.append([dx, dy, dz])
        #stlFiles取得
        stlFileName = fileName.split("/")[-1]
        stlFiles.append(stlFileName)
    return [stlFiles, fileFmt, solidNames, stlSize]

#  isBinaryStl
#    binaryファイルかどうかチェック
#    header(80byte)を除いた9文字をチェック
def isBinaryStl(fileName):
    f=open(fileName); cont=f.read(100); f.close()
    if len(cont) <100:
        return False

    ans = False
    i = 81
    while i<90:
        if ((" " <= cont[i] and cont[i] <= "z") or 
            cont[i] == "\n" or cont[i] == "\r" or cont[i] == "\t"):
            pass
        else:
            ans = True
            break
        i += 1
    return ans 

#  getAsciiSolidNameStlSize
#    asciiのstlファイルからsolidName、stlSizeを取得
def getAsciiSolidNameStlSize(fileName):
    f=open(fileName); lines=f.readlines(); f.close()
    #solidName取得
    solidName = ""
    if lines[0][:5] == "solid":
        words = lines[0].split()
        if len(words) >= 2:
            solidName = lines[0].split()[1]
    #stlSize取得
    xValues=[]; yValues=[]; zValues=[]
    for line in lines:
        if line.find("vertex") >= 0:
            values = line.split()
            xValues.append(float(values[1]))
            yValues.append(float(values[2]))
            zValues.append(float(values[3]))
    return [solidName, xValues, yValues, zValues]    

#  getBinSolidNameStlSize
#    binaryのstlファイルからsolidName、stlSizeを取得
def getBinSolidNameStlSize(fileName):
    f=open(fileName); cont=f.read(); f.close()
    #header部を取得
    i = 80
    header = cont[:i]
    #solidNameを取得
    solidName = ""
    for chara in header:
        if " " <= chara and chara <= "z":
            solidName += chara
        else:
            break
    #三角形の数
    num = struct.unpack("1i", cont[i:i+4])
    nTet = num[0]
    i += 4
    #座標を取得
    xVal=[]; yVal=[]; zVal=[]
    while i<len(cont):
        num = struct.unpack("12f", cont[i:i+48])
        #単位ベクトルはスキップ
        xVal += [num[3]] + [num[6]] + [num[9]]
        yVal += [num[4]] + [num[7]] + [num[10]]
        zVal += [num[5]] + [num[8]] + [num[11]]
        #最後の2byte分も加えてスキップ
        i += 48 + 2
    return [solidName, xVal, yVal, zVal]

#  getValueLog10
#    値を2桁に丸める
def getValueLog10(x):
    if x<=0.0:
        return 0.0
    lx = math.log10(x)
    if lx>0.0:
        llx = 10**float(int(lx) - 1)
    else:
        llx = 10**float(int(lx) - 2)
    xx = int(x/llx + 0.5) * llx
    return xx



if __name__ == "__main__":
    import gettext
    treeFoamPath = os.environ["TreeFoamPath"]
    gettext.install("treefoam", treeFoamPath + "/data/locale")

    caseDir = sys.argv[1]
    stlDir = sys.argv[2]

    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
